#ifndef ASSIST_H
#define ASSIST_H

#include <Pix.h>

#include "node.h"
#include "place.h"
#include "transition.h"


#define VOV_MODEL_TRACE_ABSOLUTE_PATH_DEFAULT "$OCTTOOLS/lib/vov/TRACES/"


class VovVar {
    String name;
    String cvalue;
    String nvalue;
 public:
    VovVar();
    VovVar( String& n, String& cv, String& nv );
    void set( String& n, String& cv, String& nv );
    void operator= ( VovVar& v ) { name = v.name; cvalue=v.cvalue; nvalue=v.nvalue; }
    String getName() { return form( "${%s}", (char*)name ); }
    String& newValue() { return nvalue; }
    String& oldValue() { return cvalue; }
    String to_new( String& s );
    String to_old( String& s );
    String to_var( String& s );
    String format();
    friend class VovVarSet;
};

class VovVarSet {
    int size;
    int count;
    VovVar* array;
    void resize( int ns );
 public:
    VovVarSet();
    void add( VovVar& );
    Pix first();
    void next( Pix& );
    VovVar& operator()( Pix& );
};


extern VovStatus VA_execTrace( VovTrace& mainTrace, VovTrace& trace, VovNodeSet& scriptset );
extern VovStatus VA_prepareTrace( VovTrace& mainTrace, VovTrace& trace, VovNodeSet& transet, VovVarSet& varSet );
extern VovStatus VA_setupInputs( VovTrace& mainTrace, VovTrace& trace, VovTransition& tran, VovNodeSet& set, VovVarSet& varSet  );
extern VovStatus VA_copyOnePlace( VovTrace& mainTrace, VovTrace& trace, VovPlace& place, VovNodeSet& set, VovVarSet& varSet );
extern String shortTraceName( String trace );


extern void VA_hardcopyNotes( VovObject& obj );
extern VovStatus VA_hardcopy( String& traceName, String& setName );

extern void vovLongMessage( String& title, String& msg, int rows, int cols );
extern void vovEditSet( VovTrace& trace, VovNodeSet& set );




#endif /* ASSIST_H */
