/* Information kept by the server about each of its clients */

#include "clients.h"
#include "slaveset.h"
#include "voverror.h"

Client::Client()
{
}

Client::~Client()
{
}

void Client::start(int i)
{
    Bzocket::start(i);
    startDate.now();
    lastDate.now();
    requestId = 0;
    totTime = 0.0;
    theTransition = 0;
    thePlace = 0;
    theGoal = 0;
    theSet = 0;
    slaveset = 0;
    pid = 0;
    _class = 0;
}

void Client::startService()
{
    requestId++;		// Count the number of requests.
    getDate( startTime );
}

void Client::endService()
{
    totTime += getDateInterval( startTime );
}

void Client::close()
{
    // Do not print anything. Instead, we should do some statistical analysis
    // on the time required to service the client.
    int echoServiceTime = 1;
    if ( echoServiceTime ) {
	double ave = ( requestId > 0 ) ? totTime / requestId : 0.0;
	vovMessage( signature() + form( "\t: %4d req in %.3fs (ave=%.4f s/req)", requestId, totTime, ave) );
    }
    Bzocket::close();
}

String Client::signature()
{
    String s = user + "@" + host ;
    return s;
}

String Client::format()
{
    String s = "Client: " + signature();
    return s;
}


