#include "port_internal.h"
#include "utcc.h"

String vov_prettyTime( int s )
{
    if ( s < 60 ) return form( "%ds", s );
    int min = s / 60;
    s = s % 60;
    if ( min < 60 ) return form( "%dm%ds", min, s );
    int h = min / 60;
    min = min % 60;
    return form( "%dh%dm", h, min );
}


// this is the same as st_strhash, from the st package.
// Hopefully, this will give a better hashing than hashpjw();
int vov_strhash( char* string, int modulus  )
{
    register int val = 0;
    register int c;
    
    while ((c = *string++) != '\0') {
	val = val*997 + c;
    }

    return ((val < 0) ? -val : val)%modulus;
}


String vov_stdoutRedirect( String& commandline )
{
    // hashpjw() dwas tried and did not give a good result.
    int unique_id = vov_strhash( (char*)commandline, 0x00ffffff );
    String clps = commandline;		// Collapse the commandline without white spaces.
    clps.gsub( RXwhite, "" );		// 
    if ( clps.at( 0, 4) == "vov_" ) {
	clps = clps.at(4, 5 );		// Skip the "vov_"  prefix.
    } else {
	clps = clps.at(0, 5 );
    }
    String stdoutname = form(".std.%s.%d", (char*)clps, unique_id ) ;
    return stdoutname;
}


String vov_normalizeString( const String& line )
    // Replace all white space with just one space.
    // Also remove leading and trailing white space.
{
    // We do not know if line has leading or trainling WS. Add some WS any way.
    // Then we can always strip it.
    String normalizedString = " " + line + " "; 		// 
    int changes =  normalizedString.gsub( RXwhite, " " );	// Replace white space with 1 blank.
    if ( normalizedString.length() < 3 ) {			// 
	return 0;						// 
    }								// 
    return normalizedString.at( 1, normalizedString.length() - 2 ); // Strip leading and trailing space.
}

String vov_signature()
{
    String host = utcc_getenv( "VOV_HOST_NAME" );
    String project = utcc_getenv( "VOV_PROJECT_NAME" );
    return project + "@" + host;
}

String vov_stripWord( String& sentence )
{
    String word;
    if ( sentence.length() ) {
	word = sentence.before( RXwhite );
	if ( word == 0 ) {
	    word = sentence;
	    sentence = 0;
	} else {
	    sentence = sentence.after( RXwhite );
	}
    }
    return word;
}
