#include "String.h"

extern "C" 
{
/* Do not include port.h" */

#define PORT_H
typedef int int32;
#include "oct.h"
#include "oh.h"
}

#define strsav(s)	strcpy(malloc((unsigned) (strlen(s)+1)), s)

#define LAMBDA	20


struct net_length_struct {
    octId objectId;		/* Net id. */
    long  length;		/* Length of segments. */
    long  area;			/* Area of all paths. */
    long  bbox_length;		/* BB of net. */
};


struct ChipNets {
 public:
    int 	num_nets;
    struct net_length_struct *netArray;
    double	total_net_length;
    double 	total_net_length2;
    double 	total_net_length_var;
    double	total_net_area;
    double  	total_net_area2;
    double  	total_net_area_var;
    ChipNets() {
 	num_nets = 0;
	netArray = 0;
	total_net_length = 0;
 	total_net_length2 = 0;
 	total_net_length_var = 0;
	total_net_area = 0;
  	total_net_area2 = 0;
  	total_net_area_var = 0;
    }
    int main( octObject* facet, int bb );
    int all_net_lengths(  octObject *facet );
    String format( int bb = 0, int max = 6 );
};

class ChipInstances {
 public:
    int	num_instances;
    int	num_connectors;
    int	num_vias;
    double	tot_instance_area;
    double	tot_instance_area2;
    double	tot_instance_area_var;
    ChipInstances() {
	num_instances = 0;
	num_connectors = 0;
	num_vias = 0;
	tot_instance_area = 0.0;
	tot_instance_area2 = 0.0;
	tot_instance_area_var = 0.0;	
    }
    void main( octObject* facet );
    String format();
};

class ChipArea {
 public:
    int		chipWidth;
    int		chipHeight;
    int		chipArea;
    ChipArea() {
	chipWidth = 0;
	chipHeight = 0;
	chipArea = 0;
    }
    void main( octObject* facet );
    String format();
};

extern void FatalError( String&  );
extern void Warning( String& );
