/* -*- C++ -*- */
#ifndef CHAIN_H
#define CHAIN_H
#pragma once

#include "place.h"

#define VOV_CHAIN_OCTMASK OCT_NET_MASK

class VovChainInfo : public VovObject {
    VovBag    first;		// Containing the first place in a chain.
    VovBag    current;		// Containing the current place in a chain.
    VovBag    last;		// Containing the last place in a chain.
public:
    VovChainInfo( );
    ~VovChainInfo();
    VovStatus create( VovPlace& firstPlace, VovPlace& secondPlace );
    VovStatus get();
    VovStatus del();
    VovStatus destroy();
    VovStatus setCurrent( VovPlace& );
    VovStatus addPlace( VovPlace& );
    VovStatus delPlace( VovPlace& );
    void      getCurrent( VovPlace& );
    void      getFirst( VovPlace& );
    void      getLast( VovPlace& );

    // VovStatus split( VovPlace& , VovTransition& , VovPlace& );
    // VovStatus merge( VovPlace& , VovTransition& , VovPlace& );
    
    int position( VovPlace& );
    int length();
    VovStatus precedes( VovPlace&, VovPlace& );
    VovStatus getNext( VovPlace&, VovPlace& );
    VovStatus getPrec( VovPlace&, VovPlace& );

    String format();
    String name() { return contents.net.name; }
    VovStatus OK();			// Check integrity of chain.
    VovStatus fix();			// Fix a broken chain.
    friend class VovPlace;
};

#endif
