// -*- C++ -*-
/*
 * invalidate.h
 *
 * This file describes the data structures to represent the events occurring during an invalidation
 */
#ifndef INVALIDATE_H
#define INVALIDATE_H
#include "node.h"

class  VovInvalidateInfo {
public:
    octId    place_id;		// Place that is being invalidated.
    VovNodeStatus status;	// The new status used for invalidation.
    int      places;		// Number of invalidated places.
    int	     transitions;	// Number of invalidated transitions.
    int      durations;		// Total expected duration of invalidated transitions.
    int	     revive;		// True, if dead nodes can be changed of status.
    String msg;			// A composite message.

    VovInvalidateInfo( VovNode&, VovNodeStatus s );
    ~VovInvalidateInfo();
    String format();
};

#endif	/* INVALIDATE_H */


