/* Level the graph using forward breadth first search */
#include "node.h"

VovStatus VT_levelmin_output_level( VovNode& node , void* data )
{
    int* level = (int*)data;
    if ( node.getLevel() < *level ) {
	*level = node.getLevel();
    }
    return VOV_OK;
}

VovStatus  VT_levelbefore(VovNode& node, void* lev)
{
    int* l = lev;
    *l = node.getLevel();
    return VOV_OK;
}

VovStatus VT_levelvisit_in(VovNode& node, void* l)
{
    int* lev = l;
    if ( node.hasInputs() == VOV_NOT_OK ) {
	int newlevel = *lev - 1;
	if (newlevel < node.getLevel() ) {
	    node.setLevel( newlevel );
	}
    }
    return VOV_OK;
}

VovStatus VT_levelvisit_out(VovNode& node, void* l)
{
    int* lev = l;
    int newlevel = *lev + 1;
    if (newlevel > node.getLevel() ) {
	node.setLevel( newlevel );
    }
    return VOV_OK;
}

VovStatus VT_levelafter(VovNode& node, int* data)
{
    if (data) ;			/* ignore data */
    if ( node.hasInputs() == VOV_NOT_OK ) {
	int minLevel = 100000;	/* inpossibly high level  */

	node.foreachOutput( VT_levelmin_output_level, (void*)&minLevel );
	if (node.getLevel() < minLevel - 1 )  {
	    node.setLevel( minLevel - 1 );
	}
    }
    return VOV_OK;
}


