// This may look like C code, but it is really -*- C++ -*-

#ifndef RETRACE_H
#define RETRACE_H
#pragma once

#include "base.h"
#include "node.h"
#include "vovinternal.h"

extern class VovTransition;
extern class String;

#define VOV_RETRACE_OCTMASK OCT_BAG_MASK

typedef enum _vovRetraceStatus {
    VOV_RETRACE_IN_PROGRESS,
    VOV_RETRACE_DONE,
    VOV_RETRACE_ERROR
} VovRetraceStatus;


class VovRetrace : public VovNodeSet {
    VovProp estimatedDuration;			// 
    VovProp actualDuration;			// 
    VovProp startDate;				// 
    VovProp status;				// 
 public:
    VovRetrace();
    VovRetrace( String& s );
    VovRetrace( VovRetrace& );
    ~VovRetrace();
    
    VovStatus start( String& msg );
    VovStatus terminate( VovTransition& t );
    VovStatus stop( String& msg );
    VovStatus create();
    VovStatus get();
    VovStatus del();
    
    String format();

    void pack( Bzocket& );
    void unpack( Bzocket& );

};
#endif
