/* -*- C++ -*- */

#ifndef SELECT_H
#define SELECT_H
#pragma once

#include "String.h"
#include "base.h"
#include "vovinternal.h"

extern class VovNode;
extern class Bzocket;

#define VOV_SOURCE_MASK 0x100
#define VOV_SINK_MASK   0x200

class VovSelectRule : public VovObject {
    VovProp typemask;		// Node type, place, trans, source, sink.
    VovProp type2mask;		// Place type: unix_file, facet, etc.
				// Trans type: batch, interactive, etc.
    VovProp statusmask;		// Node status, valid, not valid, dead, etc.
    VovProp rx;			// Regular expression.
public:
    int debug;			// Public debug flag.

    VovSelectRule();
    VovSelectRule( VovSelectRule& );
    VovSelectRule( int tm, int t2m,  int sm, String& r );
    ~VovSelectRule();

    void set(  int tm, int t2m,  int sm, String& r );
    void create();
    void get();
    void modify();
    void del();

    
    VovStatus edit();
    void setupDialog( VovDialog& top_dialog, VovDialogHandles& data );
    VovStatus readDialog( VovDialogHandles& data );

    int select( VovNode& );
    void pack( Bzocket& );
    void unpack( Bzocket& );
    
    String format();
};


#define SELECT_ALL  ".*"
#define SELECT_NONE "XYZ"
#define SELECT_OCT  ".+:.+"



#endif



