// This may look like C code, but it is really -*- C++ -*-

#ifndef SLAVESET_H
#define SLAVESET_H

#include "clients.h"

typedef enum {SLAVE_BUSY, SLAVE_IDLE, SLAVE_DONE, SLAVE_OVERLOADED } VovSlaveStatus;
typedef struct _vovSlave {
    Client* client;			// Pointer to the slave client.
    int     power;			// Relative power of this slave.
    VovSlaveStatus     status;		/*  */
    int     estDuration;
    int     startDate;
    String  affinity;			// A string to match with the affinity of a transition.
    int     pid;			// The process id for the slave.
} VovSlave;


class SlaveSet {
    int numberOfSlaves;
    int numberOfWorkingSlaves;
    VovSlave* slaves;		// Array of slaves.
    int index( Client* );
 public:
    SlaveSet( int s ) { 
	slaves = new VovSlave[s]; 		// Allocate slave array
	numberOfSlaves = 0;			// 
	numberOfWorkingSlaves = 0;		// 
    }
    SlaveSet( SlaveSet& );
    ~SlaveSet();

    int  length(){ return numberOfSlaves; } 	// 
    int  availableSlaves();			// 
    int  first();				// 
    void next( int& );				// 
    Client* operator()( int ) ;			// 
						// 
    void getInfo( String& );			// 
						// 
    VovStatus add( Client*, int power, const String& affinity ); // 
    VovStatus del( Client* );				   // 
    VovStatus bestSlave( Client**, const String& affinity );	   // 
    void slaveBegin( Client*, int duration );				   // 
    void slaveEnd( Client* );				   // 
    String format( );					   // 
};

#endif
