/* -*- C++ -*- */
#ifndef USER_H
#define USER_H
#pragma once

#include "base.h"
#include "vovinternal.h"
#include "transition.h"

#define VOV_USER_OCTMASK OCT_INSTANCE_MASK

class VovUser : public VovObject {
    VovProp lastCreation;	// Date of creation of a new transition.
    VovProp lastConnection;	// date of last connection to server.
    VovBag  activeSet;		// What the user has been doing lately.
public:
    VovUser( String& );		// 
    VovUser( octId );		// 
    ~VovUser();			// 
    VovStatus create();		// 
    VovStatus get();		// 
    VovStatus active(VovTransition&);		// The user is active now.
    VovStatus connected();			// The user is connected now.
    char* getCellName();

    void doPlacement();
    
    String getName();
    String format( int extended = 0 );

    void pack( Bzocket& );
    void unpack( Bzocket& );
};



#endif /* USER_H */
