// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of GNU CC.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the GNU CC General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
GNU CC, but only under the conditions described in the
GNU CC General Public License.   A copy of this license is
supposed to have been given to you along with GNU CC so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies.  
*/


#ifndef _StringintMap_h
#pragma once
#define _StringintMap_h 1

#include <Pix.h>
#include "Stringdefs.h"

class StringintMap
{
protected:
  int                   count;
  int                   def;

public:
                        StringintMap(int  dflt);

  int                   length();                // current number of items
  int                   empty();

  virtual int           contains(String& key);      // is key mapped?

  virtual void          clear();                 // delete all items

  virtual int&          operator [] (String& key);  // access contents by key

  virtual void          del(String& key);           // delete entry

  virtual Pix           first();                 // Pix of first item or 0
  virtual void          next(Pix& i);            // advance to next or 0
  virtual String&          key(Pix i);              // access key at i
  virtual int&          contents(Pix i);         // access contents at i

  virtual int           owns(Pix i);             // is i a valid Pix  ?
  virtual Pix           seek(String& key);          // Pix of key

  int&                  dflt();                  // access default val

  void                  error(char* msg);
  virtual int           OK();                    // rep invariant
};


inline int StringintMap::length()
{
  return count;
}

inline int StringintMap::empty()
{
  return count == 0;
}

inline int& StringintMap::dflt()
{
  return def;
}

inline StringintMap::StringintMap(int  dflt) :def(dflt)
{
  count = 0;
}


#endif
