// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of GNU CC.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the GNU CC General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
GNU CC, but only under the conditions described in the
GNU CC General Public License.   A copy of this license is
supposed to have been given to you along with GNU CC so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies.  
*/


#ifndef _StringintVHMap_h
#pragma once
#define _StringintVHMap_h 1

#include "dateMap.h"


class StringintVHMap : public StringintMap
{
protected:
  String*           tab;
  int*           cont;
  char*          status;
  int            size;

public:
                StringintVHMap(int  dflt,int sz=DEFAULT_INITIAL_CAPACITY);
                StringintVHMap(StringintVHMap& a);
                ~StringintVHMap();

  int&          operator [] (String& key);

  void          del(String& key);

  Pix           first();
  void          next(Pix& i);
  String&          key(Pix i);
  int&          contents(Pix i);

  Pix           seek(String& key);
  int           contains(String& key);

  void          clear(); 
  void          resize(int newsize = 0);

  int           OK();
};


inline StringintVHMap::~StringintVHMap()
{
  delete [size] tab;
  delete [size] cont;
  delete [size] status;
}

inline int StringintVHMap::contains(String& key)
{
  return seek(key) != 0;
}

inline String& StringintVHMap::key(Pix i)
{
  if (i == 0) error("null Pix");
  return *((String*)i);
}

inline int& StringintVHMap::contents(Pix i)
{
  if (i == 0) error("null Pix");
  return cont[((unsigned)(i) - (unsigned)(tab)) / sizeof(String)];
}


#endif
