#include "port_internal.h"
#include "ddsplus.h"


extern int vovInitX();

int useXinterface( int newstatus = -1 )
{
    if ( getenv( "DISPLAY" ) == 0 ) {
	return 0;
    } else {
	return vovInitX();
    }
}


int ttyUserDecision( String& question, String& option1, String& option2 )
{
    int errors_allowed = 3;
    
    cerr << "---------------------------------------------\n";
    cerr << "---- USER DECISION REQUIRED -----------------\n";
    cerr << "---------------------------------------------\n";
    cerr << question << "\n";
    cerr << "(1) " <<  option1 << "\n";
    cerr << "(2) " <<  option2 << "\n";
    cerr << "(a) Abort (s) Skip\n";
    do {
	cerr << "\nWhich one ? (1,2,a,s) -->";
	String answer;
	cin >> answer;
	if ( answer == "a" ) return -1;
	if ( answer == "s" ) return 0;
	if ( answer == "1" ) return 1;
	if ( answer == "2" ) return 2;
	
	for (int i = 0 ; i < 3; i++) cerr << "\n\t\tIllegal answer: " << answer ;
    } while  ( errors_allowed-- );

    cerr << "Too many errors: skipping \n";
    return 0;			// treat this error like a skip
}

String userString( String& prompt )
{
    cerr << prompt;
    String line;
    cin >> line;
    return line;
}

#ifdef OBSOLETE
String ttyUserText( String& title )
{
    cerr << "---------------------------------------------\n";
    cerr << "---- USER TEXT INPUT REQUIRED ---------------\n";
    cerr << "---------------------------------------------\n";
    cerr << title << "\n";

    String text;
    String line;
    do {
	line = userString( ">>" );
	text += line;
    } while  ( line != 0 );

    return text;
}

String userText( String& title )
{
    if ( useXinterface() ) {
	int cols = 40;
	int rows = 4;
	dmTextItem item[1] = {{ "Text->", rows, cols, "default text", 0 }};
	if ( dmMultiText( (char*)title, 1, item ) == DM_OK ) {
	    return (String)item[0].value;
	} else {
	    return 0;
	}
    } else {
	return ttyUserText( title );
    }
}
#endif

int userDecision( String& question, String& option1, String& option2 )
{
    if ( useXinterface() ) {
	String title = "USER DECISION";
	String  s = vovConfirm( title, question, option1, option2 );
	return ( s == option1 ) ? 1 : 2 ;
    }
    return ttyUserDecision( question, option1, option2 );
}
