#include <stream.h>

extern "C"
{
#include <sys/time.h>
#include <sys/resource.h>
}

void memoryleak( char* routinename, int checkpoint ) 
{
    extern char end, edata, etext;

    static int prev_size = 0;

    int cur_size = (char*)sbrk(0) - (char*)&end;

    if ( ! checkpoint) {
	if ( cur_size > prev_size ) {
	    int delta = cur_size - prev_size;
	    cerr.form("DATA MEMORY LEAK (in %s) : Was %d: Is %d: Delta %d\n",
		      routinename, prev_size, cur_size, delta );
	    cerr.form("sbrk(0)= %d, end = %d, edata = %d, etext = %d\n", 
		      sbrk(0), &end, &edata, &etext);
	}
    }
    prev_size = cur_size;
    return;
}

void OLDbuggymemoryleak( char* routinename, int checkpoint ) 
{
    extern int getrusage( int, void* );
    static int prev_stack = 0;	// previous amount of stack memory
    static int prev_data = 0;	// previous amount of data memory
    struct rusage rusage;

    getrusage( 0, &rusage);

    if ( ! checkpoint) {
	int cur_stack = rusage.ru_isrss;
	int cur_data =  rusage.ru_idrss;
	
	if ( cur_data > prev_data ) {
	    int delta = cur_data - prev_data;
	    cerr.form("DATA MEMORY LEAK (in %s) : Was %d: Is %d: Delta %d\n",
		      routinename, prev_data, cur_data, delta );
	}
	if ( cur_stack > prev_stack ) {
	    int delta = cur_stack - prev_stack;
	    cerr.form("STACK MEMORY LEAK (in %s) : Was %d: Is %d: Delta %d\n",
		      routinename, prev_stack, cur_stack, delta );
	}
    }

    prev_stack = rusage.ru_isrss;
    prev_data =  rusage.ru_idrss;
    
    return;
}
