/* -*- C++ -*- */
#ifndef ANNOTATION_H
#define ANNOTATION_H
#pragma once

#include <String.h>
#include "base.h"
#include "vovinternal.h"

#define VOV_ANNOTATION_OCTMASK OCT_PROP_MASK

class VovAnnotation : public VovProp {
    VovProp signature;		/* Author of the note. */
    VovProp date;
public:
    VovAnnotation();
    VovAnnotation( String& );
    VovAnnotation( String&, String& );
    ~VovAnnotation();
    VovStatus create();
    VovStatus get();
    VovStatus modify();
    VovStatus del();
    String format(); 
    VovStatus edit();
    void setupDialog( VovDialog& top_dialog, VovDialogHandles& data );
    VovStatus readDialog( VovDialogHandles& data );

    void pack( Bzocket& );
    void unpack( Bzocket& );
};

// Let's put a limit to the number of annotations per object.
// This simplifies the job of getting annotations.
#define VOV_MAX_ANNOTATIONS 20


#endif
