/* -*- C++ -*- */
#ifndef CLIENTS_H
#define CLIENTS_H

/* C++ includes */
#include <stream.h>
#include <builtin.h>

/* C includes */

/* Local includes */
#include "bzocket.h"
#include "trace.h"
#include "date.h"

extern class SlaveSet;

#define CLIENT_CLASS_SLAVE   0x1
#define CLIENT_CLASS_NOTIFY  0x2

class Client : public Bzocket{
    Date	startDate;	// When this connection was started.
    Date        lastDate;	// last action requested by this client.
    int		requestId;	// Is this really used ?.
    struct timeval startTime;	// Uset to compute service time.
    double      totTime;	// seconds of CPU used to service this client.
    int         _class;		//
 public:
    int		theTransition;	// The default transition.
    int		thePlace;	// The default place.
    int		theGoal;	// The default goal.
    int		theSet;		// The default nodeset.
    Client();
    ~Client();
    SlaveSet*   slaveset;	//
    String	user;		// Who is doing this.
    String 	host;		// From which machine.
    int		pid;		// Process id for this client.
    int         nesn;		// Notified event serial number.

    void  	start(int);	// 
    void        startService();
    void	endService();
    void	close();	// Virtual in Bzocket.
    int&	clientclass() { return _class;}
    String	signature();	// user@host
    String	format();	// Textual info about the client.
};

#endif /* CLIENTS_H */

