// This may look like C code, but it is really -*- C++ -*-

#ifndef INTMASK_H
#define INTMASK_H


#define INT_SIZE  ( sizeof( int ) * 8 )   // Size of integer times number of bits in a byte.

class Intmask {
    int* maskptr;		// 
    int  size;			// 
    int firstbit;		// 
    int lastbit;		// 
    int count;			// How many bits are 1.
 public:
    Intmask( int length = INT_SIZE );	// 
    Intmask( Intmask& m );	// 
    ~Intmask();			// 
    void resize( int length );
    inline int  first() {
	return firstbit;
    }
    inline int  last() {
	return lastbit;
    }
    inline int* mask() {
	return maskptr;
    }
    inline int  test(int i) {
	int b  = i / INT_SIZE;		// Which word.
	int ii = i % INT_SIZE;		// Index in word.
	return  maskptr[b] & (1<<ii) ;	// Test.
    }
    inline int  length(){
	return count;
    }
    virtual void clear();
    virtual void add(int);
    virtual void del(int);
    virtual void fix();
    virtual void print();
    virtual void OK();
    void    error( char* );	/*  */
    friend class RoundRobinSelector;
};


class RoundRobinSelector : public Intmask {
    int rr;			/* round robin index */
 public:
    RoundRobinSelector();
    ~RoundRobinSelector();
    int  index();
    int  next();
    void clear();
    void add(int i);
    void del(int i);
    void print();
    void OK();
};

#endif
