// This may look like C code, but it is really -*- C++ -*-


#ifndef PLACEMATRIX_H
#define PLACEMATRIX_H
#pragma once

#include "vovinternal.h"

extern class VovNodeSet;

class VovPlacementMatrix {
    int size_cols;
    int size_rows;
    int **matrix;
    int *row_first;
    int *row_last;
    int *row_entries;
 public:
    VovPlacementMatrix( int , int );
    ~VovPlacementMatrix();

    VovStatus init( VovNodeSet& set );
    void resize( int, int );
    VovStatus checkBoundaries( int, int );
    
    int get( int row , int col ) { return (checkBoundaries( row, col) == VOV_OK ) ? matrix[row][col] : 0; }
    VovStatus add( int id, int row , int col );
    VovStatus del( int id, int row , int col );
    VovStatus verify( int id, int row , int col );
    
    int getFirstSpot( int row );
    int getClosestSpot( int row, int target, int current );
    VovStatus OK();
    int pairwiseInterchanges();		// Returns the number of interchanges made.
};

#endif
